# Script to create figures of gEBV accuracy#
# Este script esta corregido sin errores 15/October/2020

#setwd( "/media/samuel/ONE_PIECE/2021_GS_simulation")
getwd()
sec <- proc.time()
options(max.print =100000000)
options(width = 10000)
# colocar estas opciones significan que tendras hasta 10,000 espacios de caracteres para imprimir tus resultados
# y tendras un millon de lineas para imprimirlas
options(scipen = 999) # Disable scientific notation options
options(digits = 10) # set up the number of digits after a point.
options(pillar.sigfig = 10)

library(ggplot2);  library(ggsci);  library(scales); library("dplyr")

data_gEBV <- read.table(file ="gEBV_accuracy_data_cg_15th_Oct_FINAL_.txt",header = TRUE,
                        colClasses = c(rep("factor",2), "integer", "character",rep("numeric",5)))
head(data_gEBV);str(data_gEBV)
data_gEBV [1:10,1:8]

samu_colour <- c("#FF6F00FF","#1A5354FF","#C71000FF","#8A4198FF","#FF95A8FF","#00CC33FF","#0A47FFFF","#EFC000FF","#6EE2FFFF")

data_gEBV $Scenario <- factor(data_gEBV $Scenario, levels = c("BLUP",1,2,3,8,4,5,6,7))
levels(data_gEBV $Scenario)[levels(data_gEBV $Scenario)=="1"] <- "S1"
levels(data_gEBV $Scenario)[levels(data_gEBV $Scenario)=="2"] <- "S2"
levels(data_gEBV $Scenario)[levels(data_gEBV $Scenario)=="3"] <- "S3"
levels(data_gEBV $Scenario)[levels(data_gEBV $Scenario)=="4"] <- "S4"
levels(data_gEBV $Scenario)[levels(data_gEBV $Scenario)=="5"] <- "S5"
levels(data_gEBV $Scenario)[levels(data_gEBV $Scenario)=="6"] <- "S6"
levels(data_gEBV $Scenario)[levels(data_gEBV $Scenario)=="7"] <- "S7"
levels(data_gEBV $Scenario)[levels(data_gEBV $Scenario)=="8"] <- "S3_A"
levels(data_gEBV $Scenario)[levels(data_gEBV $Scenario)=="BLUP"] <- "BLUP"
data_gEBV [1:10,]
levels(data_gEBV $Scenario)

samu_colour <- c("S1"="#FF6F00FF","S2"="#1A5354FF","S3"="#C71000FF","S3_A"="#8A4198FF","S4"="#FF95A8FF","S5"="#00CC33FF","S6"="#0A47FFFF","S7"="#EFC000FF","BLUP"="#6EE2FFFF")

str(data_gEBV)

# GRAFICAR en GGPLOT2

begin <- ggplot(data = data_gEBV,aes(x=data_gEBV$Scenario,y=data_gEBV$Accuracy_using_gv,fill=data_gEBV$Scenario)) + geom_boxplot(size=0.25,aes(fill = data_gEBV$Scenario),outlier.colour = NA) 

# begin <- ggplot(data = data_gEBV ,aes(x=data_gEBV $Scenario,y=data_gEBV $Mean,ill=data_gEBV $Scenario,colour=data_gEBV $Scenario)) + geom_dotplot(binwidth = 0.00125, binaxis = "y", stackdir = "center",position = "dodge") 

begin

begin <- begin + scale_fill_manual(values = samu_colour,breaks=c("BLUP","S1","S2","S3","S3_A","S4","S5","S6","S7"),name="Scenarios") + theme_bw() + 
  #  stat_summary(fun.y="mean", geom="point", shape=23, size=2.5, color="red", fill="white") +
  theme(plot.title= element_text(size=20, face="bold"),
        axis.title.x= element_text(size=20, face="bold", colour="black",vjust=0),
        axis.text.x= element_text(size=16, face="bold", colour="black"),
        axis.title.y= element_text(size=22, face="bold", colour="black",hjust=0.5, vjust=1),
        axis.text.y= element_text(size=16, face= "bold", colour="black",angle=0, hjust=0.5, vjust=0.5),
        legend.title= element_text(size=16, face="bold"),
        legend.text= element_text(size=16, face="bold"),
        panel.grid.major = element_line(colour= "gray75", linetype="2222"),
        panel.grid.minor = element_line(colour= "white", linetype= "1111"))

follow <- begin + labs(x="QTN Model",y="Mean of EBV Accuracy") + geom_point(aes(fill=data_gEBV$Scenario),shape=21,size=1.5, position=position_jitterdodge(dodge.width=0.8,jitter.width = 1)) + 
  scale_fill_manual(values = samu_colour,breaks=c("BLUP","S1","S2","S3","S3_A","S4","S5","S6","S7"),name="Scenarios") +
  guides(fill = guide_legend(override.aes = list(color = NA)), color = FALSE, shape = FALSE) +
  scale_y_continuous(breaks=seq(0.00,0.80,0.05),limits = c(0.00,0.80))

follow <- follow +  stat_summary(fun.y="mean", geom="point", shape=23, size=2.5, color="red", fill="white")

follow
final <- follow + facet_wrap(~data_gEBV $Number_QTN) + theme(strip.text.x = element_text(size = 16, color = "black", face = "bold.italic"))
final

# facet_wrap(~Number_of_QTN,scales = "free")

ggsave(filename = "Plot_of_EBV_accuracy_14_9_new.png", plot = final,device = "png",path = NULL,
       scale = 1,width = 14, height = 9, units = "in", dpi = 600, limitsize = TRUE)

# Exploratory analysis or descriptive analysis
# using dplyr

which(is.na(data_gEBV))

resume_QTN44 <-
  data_gEBV %>%
  filter(Number_QTN == "QTN_44" ) %>%  
  group_by(Scenario) %>%
  summarize(mean_scena = round(mean(Accuracy_using_gv, na.rm = FALSE),digits = 6),
            SD_scena = round(sqrt(var(Accuracy_using_gv, na.rm = FALSE)),digits = 6),
            Min_scena = round(min(Accuracy_using_gv, na.rm = FALSE),digits = 6),
            Max_scena = round(max(Accuracy_using_gv, na.rm = FALSE),digits = 6),
            SE_scena = round(sqrt(var(Accuracy_using_gv, na.rm = FALSE)) / sqrt(36),digits = 6),
            min_Int_95 = mean_scena - 1.96 * SE_scena,
            max_Int_95 = mean_scena + 1.96 * SE_scena,
            SE_mean_min = round(min(mean_SE,na.rm = FALSE),digits = 6),
            SE_mean_max = round(max(mean_SE,na.rm = FALSE),digits = 6),
            real_var_min = round(min(real_variance_true_BV,na.rm = FALSE),digits = 6),
            real_var_max = round(max(real_variance_true_BV,na.rm = FALSE),digits = 6))

resume_QTN44 <- as.data.frame(resume_QTN44)
resume_QTN44

resume_QTN5 <-
  data_gEBV %>%
  filter(Number_QTN == "QTN_5" ) %>%  
  group_by(Scenario) %>%
  summarize(mean_scena = round(mean(Accuracy_using_gv, na.rm = FALSE),digits = 6),
            SD_scena = round(sqrt(var(Accuracy_using_gv, na.rm = FALSE)),digits = 6),
            Min_scena = round(min(Accuracy_using_gv, na.rm = FALSE),digits = 6),
            Max_scena = round(max(Accuracy_using_gv, na.rm = FALSE),digits = 6),
            SE_scena = round(sqrt(var(Accuracy_using_gv, na.rm = FALSE)) / sqrt(36),digits = 6),
            min_Int_95 = mean_scena - 1.96 * SE_scena,
            max_Int_95 = mean_scena + 1.96 * SE_scena,
            SE_mean_min = round(min(mean_SE,na.rm = FALSE),digits = 6),
            SE_mean_max = round(max(mean_SE,na.rm = FALSE),digits = 6),
            real_var_min = round(min(real_variance_true_BV,na.rm = FALSE),digits = 6),
            real_var_max = round(max(real_variance_true_BV,na.rm = FALSE),digits = 6))

resume_QTN5 <- as.data.frame(resume_QTN5)
resume_QTN5

categoria <- c(rep("QTN_5",9),rep("QTN_44",9))
categoria

resume_total <- as.data.frame(cbind(rbind(resume_QTN5,resume_QTN44),categoria))
resume_total  

write.table(resume_total,file = "total_summary_gEBV_Accuracies_2021.txt",col.names = TRUE,row.names = FALSE,quote = FALSE,sep = "\t")


