# Script to create figures of imputation accuracy #
# Este script esta corregido sin errores 15/October/2020

#setwd( "/media/samuel/ONE_PIECE/2021_GS_simulation")
getwd()
sec <- proc.time()
options(max.print =100000000)
options(width = 10000)
# colocar estas opciones significan que tendras hasta 10,000 espacios de caracteres para imprimir tus resultados
# y tendras un millon de lineas para imprimirlas
options(scipen = 999) # Disable scientific notation options
options(digits = 10) # set up the number of digits after a point.
options(pillar.sigfig = 10)


library(ggplot2);  library(ggsci);  library(scales); library("dplyr")

data_IA <- read.table(file ="FINAL_15th_Oct_imputation_accuracy_data_29th_gen.txt",header = TRUE,
                      colClasses = c(rep("factor",2), "integer", "character",rep("numeric",5)))
head(data_IA)
data_IA[1:10,]

samu_colour <- c("#FF6F00FF","#1A5354FF","#C71000FF","#8A4198FF","#FF95A8FF","#00CC33FF","#0A47FFFF","#EFC000FF","#6EE2FFFF")

data_IA$Scenario <- factor(data_IA$Scenario, levels = c(1,2,3,8,4,5,6,7))
levels(data_IA$Scenario)[levels(data_IA$Scenario)=="1"] <- "S1"
levels(data_IA$Scenario)[levels(data_IA$Scenario)=="2"] <- "S2"
levels(data_IA$Scenario)[levels(data_IA$Scenario)=="3"] <- "S3"
levels(data_IA$Scenario)[levels(data_IA$Scenario)=="4"] <- "S4"
levels(data_IA$Scenario)[levels(data_IA$Scenario)=="5"] <- "S5"
levels(data_IA$Scenario)[levels(data_IA$Scenario)=="6"] <- "S6"
levels(data_IA$Scenario)[levels(data_IA$Scenario)=="7"] <- "S7"
levels(data_IA$Scenario)[levels(data_IA$Scenario)=="8"] <- "S3_A"
data_IA[1:10,]
levels(data_IA$Scenario)

samu_colour <- c("S1"="#FF6F00FF","S2"="#1A5354FF","S3"="#C71000FF","S3_A"="#8A4198FF","S4"="#FF95A8FF","S5"="#00CC33FF","S6"="#0A47FFFF","S7"="#EFC000FF")

str(data_IA)

# GRAFICAR en GGPLOT2

begin <- ggplot(data = data_IA,aes(x=data_IA$Scenario,y=data_IA$Mean,fill=data_IA$Scenario)) + geom_boxplot(size=0.25,aes(fill = data_IA$Scenario),outlier.colour = NA) 

# begin <- ggplot(data = data_IA,aes(x=data_IA$Scenario,y=data_IA$Mean,fill=data_IA$Scenario)) + geom_boxplot(size=0.25,aes(fill = data_IA$Scenario),outlier.colour = NA) 
# last line: without outlier
# begin <- ggplot(data = data_IA,aes(x=data_IA$Scenario,y=data_IA$Mean,ill=data_IA$Scenario,colour=data_IA$Scenario)) + geom_dotplot(binwidth = 0.00125, binaxis = "y", stackdir = "center",position = "dodge") 

begin

begin <- begin + scale_fill_manual(values = samu_colour,breaks=c("S1","S2","S3","S3_A","S4","S5","S6","S7"),name="Scenarios") + theme_bw() + 
                                theme(plot.title= element_text(size=20, face="bold"),
                                     axis.title.x= element_text(size=20, face="bold", colour="black",vjust=0),
                                     axis.text.x= element_text(size=16, face="bold", colour="black"),
                                     axis.title.y= element_text(size=22, face="bold", colour="black",hjust=0.5, vjust=1),
                                     axis.text.y= element_text(size=16, face= "bold", colour="black",angle=0, hjust=0.5, vjust=0.5),
                                     legend.title= element_text(size=16, face="bold"),
                                     legend.text= element_text(size=16, face="bold"),
                                     panel.grid.major = element_line(colour= "gray75", linetype="2222"),
                                     panel.grid.minor = element_line(colour= "white", linetype= "1111"))

# follow <- begin + labs(x="QTN Model",y="Mean of Imputation Accuracy") + geom_point(aes(fill=data_IA$Scenario),shape=21,size=1.5, position=position_jitterdodge(dodge.width=0.8,jitter.width = 2)) + 
# last line: for creating figure with points in the graphic

follow <- begin + labs(x="QTN Model",y="Mean of Imputation Accuracy") + geom_point(aes(fill=data_IA$Scenario),shape=21,size=1.5, position=position_jitterdodge(dodge.width=0.8,jitter.width = 0.5)) + 
            scale_fill_manual(values = samu_colour,breaks=c("S1","S2","S3","S3_A","S4","S5","S6","S7"),name="Scenarios") +
            guides(fill = guide_legend(override.aes = list(color = NA)), color = FALSE, shape = FALSE) +
            scale_y_continuous(breaks=seq(0.78,1.00,0.02),limits = c(0.78,1.00))

follow
final <- follow + facet_wrap(~data_IA$Number_QTN) + theme(strip.text.x = element_text(size = 16, color = "black", face = "bold.italic"))
final
  
# facet_wrap(~Number_of_QTN,scales = "free")

ggsave(filename = "Plot_of_imputation_and_accuracy_14_9_new.png", plot = final,device = "png",path = NULL,
       scale = 1,width = 14, height = 9, units = "in", dpi = 600, limitsize = TRUE)

# Exploratory analysis or descriptive analysis
# using dplyr

which(is.na(data_IA))

resume_QTN44 <-
data_IA %>%
  filter(Number_QTN == "QTN_44" ) %>%  
  group_by(Scenario) %>%
      summarize(mean_scena = round(mean(Mean, na.rm = FALSE),digits = 6),
                SD_scena = round(sqrt(var(Mean, na.rm = FALSE)),digits = 6),
                Min_scena = round(min(Mean, na.rm = FALSE),digits = 6),
                Max_scena = round(max(Mean, na.rm = FALSE),digits = 6),
                anim_mean_min = round(mean(Min,na.rm = FALSE),digits = 6),
                anim_mean_max = round(mean(Max,na.rm = FALSE),digits = 6),
                anim_min = round(min(Min,na.rm = FALSE),digits = 6),
                anim_max = round(max(Max,na.rm = FALSE),digits = 6))

resume_QTN44 <- as.data.frame(resume_QTN44)
resume_QTN44

resume_QTN5 <-
  data_IA %>%
  filter(Number_QTN == "QTN_5" ) %>%  
  group_by(Scenario) %>%
  summarize(mean_scena = round(mean(Mean, na.rm = FALSE),digits = 6),
            SD_scena = round(sqrt(var(Mean, na.rm = FALSE)),digits = 6),
            Min_scena = round(min(Mean, na.rm = FALSE),digits = 6),
            Max_scena = round(max(Mean, na.rm = FALSE),digits = 6),
            anim_mean_min = round(mean(Min,na.rm = FALSE),digits = 6),
            anim_mean_max = round(mean(Max,na.rm = FALSE),digits = 6),
            anim_min = round(min(Min,na.rm = FALSE),digits = 6),
            anim_max = round(max(Max,na.rm = FALSE),digits = 6)) 

resume_QTN5 <- as.data.frame(resume_QTN5)
resume_QTN5

categoria <- c(rep("QTN_5",8),rep("QTN_44",8))
categoria

resume_total <- as.data.frame(cbind(rbind(resume_QTN5,resume_QTN44),categoria))
resume_total 

write.table(resume_total,file = "total_summary_IA_2021.txt",col.names = TRUE,row.names = FALSE,quote = FALSE,sep = "\t")

