## Script to create Genotype yield Files##
# This script is correcetd without bugs to 2nd November 2020

# Run from 2021_GS_simulation
# library(ggplot2)
library("dplyr")

getwd()
sec <- proc.time()
options(max.print =100000000); options(width = 10000); options (scipen = 999) # Disable scientific notation options

system(paste('mkdir -p genotype_yield',sep = ""),wait = TRUE)

pathway <- "/SCRATCH/ablasco/2021_GS_simulation/GAMMA/"
model <- c(5,44)

id_simul=seq(1,36,1)

geno_yield=data.frame()
## count
x = 0

## Script
for (w in model) {
  ## system(paste('cd ',pathway,'QTN_',w,'Folder_Impute',sep = ""),wait = TRUE)
  setwd(paste(pathway,'QTN_',w,'/Folder_Impute',sep = ""))
  getwd()
  
  for(m in id_simul){
    
    for (h in seq(1,8,1) ) {
      if  (file.exists(paste("./HL_gblup",m,"/scene_",h,"/Imputationresults.log",sep=""))){ 
        
        system(paste("grep -A1 \"Yield\" ","./HL_gblup",m,"/scene_",h,"/Imputationresults.log | awk '{print $3}' > ",
                     "./HL_gblup",m,"/scene_",h,"/value.txt ",sep=""),wait = TRUE) 
        value=read.table(file=paste("./HL_gblup",m,"/scene_",h,"/value.txt",sep=""),header=FALSE,sep="")
        value=value[1,1]
        
        x = x + 1
        geno_yield[x,1]=m
        geno_yield[x,2]=h
        geno_yield[x,3]=paste('QTN_',w,sep = "")
        geno_yield[x,4]=round(value,digits = 6)
        
        print(paste("simul",m,"scene",h,sep="  "))
      }else{
        x = x + 1
        geno_yield[x,1]=m
        geno_yield[x,2]=h
        geno_yield[x,3]=paste('QTN_',w,sep = "")
        geno_yield[x,4]="Missing"
        
        print(paste("simul",m,"scene",h,sep="  "))
      }
    }
  }
}

colnames(geno_yield)=c("Simulation","Scene_Imputation","Number_QTN","Genotype_Yield")
title=paste("Genotype_yield_imputation_2021",".txt",sep="")
write.table(geno_yield,file = paste("../../../genotype_yield/",title,sep=""),
            sep = "\t",col.names = TRUE,row.names = FALSE,quote = FALSE)

proc.time()-sec

##### Edit file ####
geno_yield=read.table(file = "Genotype_yield_imputation_2021.txt",header = TRUE)
geno_yield[geno_yield$Genotype_Yield=="Missing",]
geno_yield[geno_yield=="Missing"] = NA

geno_yield$Genotype_Yield <- as.numeric(as.character(geno_yield$Genotype_Yield))
geno_yield$Scene_Imputation <- as.factor(as.character(geno_yield$Scene_Imputation))
str(geno_yield)

resume <-
  geno_yield %>%
  # filter(Number_QTN == "QTN_5" ) %>%  
  group_by(Scene_Imputation) %>%
  summarize(mean_scena = round(mean(Genotype_Yield, na.rm = FALSE),digits = 6),
            SD_scena = round(sqrt(var(Genotype_Yield, na.rm = FALSE)),digits = 6),
            SE_scena = round(sqrt(var(Genotype_Yield, na.rm = FALSE)) / sqrt(72),digits = 6),
            min_Int_95 = mean_scena - 1.96 * SE_scena,
            max_Int_95 = mean_scena + 1.96 * SE_scena)

resume <- as.data.frame(resume)
resume

write.table(resume,file = "total_genotype_field_2021.txt",col.names = TRUE,row.names = FALSE,quote = FALSE,sep = "\t")




